import time
import sys
import serial


print "INICIALIZUJI KOMUNIKACI S PRISTROJI"

###############################################
#zacatek inicializace komunikace s komutatorem OB11-K
SerKomutator=serial.Serial('COM12'); #arduino at port COM12
print "Komutator OB11-K je pripojen na portu: ", SerKomutator.name  #test if connection was succesfull
def Komutator(msg):
	global SerKomutator
	SerKomutator.write(bytes(msg[0]))

TimeDel=0.3
time.sleep(TimeDel)
Komutator('a')
time.sleep(TimeDel)
Komutator('b')
time.sleep(TimeDel)
Komutator('c')
time.sleep(TimeDel)
Komutator('d')
time.sleep(TimeDel)
Komutator('h')
time.sleep(TimeDel)
Komutator('k')
time.sleep(TimeDel)
#konec inicializace komunikace s komutatorem OB11-K
###############################################



###############################################
#zacatek inicializace komunikace s teplotnim kontrolerem Lakeshore 325

#NoSerPort=6  # COM7
NoSerPort=10  # COM11
TeplotniKontrolerSer=serial.Serial(NoSerPort) 
print "Spojuji Lakeshore 325 na portu RS232  cislo ", NoSerPort+1
TeplotniKontrolerSer.baudrate=9600
TeplotniKontrolerSer.parity = serial.PARITY_ODD
TeplotniKontrolerSer.bytesize = serial.SEVENBITS
TeplotniKontrolerSer.stopbits = serial.STOPBITS_ONE
TeplotniKontrolerSer.xonxoff = 0	

# send SCPI command
def TeplotniKontroler(msg):
	global TeplotniKontrolerSer
	TeplotniKontrolerSer.write(msg+"\r\n")
	return

def SetPoint(T):
	Odeslat="SETP 1,"+str(T)+"[term]"
	TeplotniKontroler(Odeslat)
	return

def HeaterOn():
	Odeslat="RANGE 1,2[term]"
	TeplotniKontroler(Odeslat)
	time.sleep(0.2)
	return

def HeaterOff():
	Odeslat="RANGE 1,0[term]"
	TeplotniKontroler(Odeslat)
	time.sleep(0.2)
	return

  
# test spojeni
TeplotniKontroler("*IDN?")
print "odpoved na *IDN?:", TeplotniKontrolerSer.readline()
#raw_input('press Enter...')

def Teplota():
  TeplotniKontroler("KRDG?")
  T=TeplotniKontrolerSer.readline()
  Tf=float(T)
  print "Teplota vzorku:", Tf
  return Tf

#konec inicializace komunikace s teplotnim kontrolerem Lakeshore 325
#############################################################


##########################################
#- inicializace komunikace se zdrojem proudu Keithely 6220
NoSerPort=7  # COM3
ZdrojProuduSer=serial.Serial(NoSerPort) 
print "Spojuji Keithely 6220 na portu RS232  cislo ", NoSerPort+1
ZdrojProuduSer.baudrate=19200
ZdrojProuduSer.parity = serial.PARITY_NONE
ZdrojProuduSer.bytesize = serial.EIGHTBITS
ZdrojProuduSer.stopbits = serial.STOPBITS_ONE
ZdrojProuduSer.xonxoff = 0	

# definice SCPI prikazu 
def ZdrojProudu(msg):
  global ZdrojProuduSer
  ZdrojProuduSer.write(msg+"\r\n")
  return

# which instrument?
ZdrojProudu("*IDN?")
print "odpoved na *IDN?:", ZdrojProuduSer.readline()
#- konec inicializace komunikace se zdrojem proudu Keithely 6220
##########################################

##########################################
#- inicializace komunikace s data acuisition unit (DAU) Agilent 34970A
#NoDAUSerPort=5  # COM6
NoDAUSerPort=9  # COM10
print "Spojuji Agilent 34970A data acquisition unit na portu RS232  ", NoDAUSerPort+1
DAUSer=serial.Serial(NoDAUSerPort) # COM6
DAUSer.baudrate=4800
DAUSer.parity = serial.PARITY_NONE
DAUSer.bytesize = serial.EIGHTBITS
DAUSer.stopbits = 1
DAUSer.xonxoff = 0
  
# definice SCPI commandu 
def DAU(msg):
  global DAUSer
  DAUSer.write(msg+"\r\n")
  return
  
# which instrument?
DAU("*IDN?")
print "odpoved na *IDN?:", DAUSer.readline()
# configure Agilent for the measurement
DAU("SYST:REM")
DAU("*RST")
time.sleep(1)  

#- konec inicializace komunikace s Agilent 34970A
##########################################



##############################################
# inicializace komunikace s zdrojem proudu pro magnet Agilent N5769A  
import visa
AgilentZdrojMagnet = visa.instrument("USB0::0x0957::0x0807::N5769A-US12M4360G::0::INSTR")
print "dotaz na *IDN? :", AgilentZdrojMagnet.ask("*IDN?")

def MagnetProud(I):
  #Set current level
  AgilentZdrojMagnet.write("CURR " + str(I))
  return

def MagnetNapeti(V):
  #Set voltage level
  AgilentZdrojMagnet.write("VOLT " + str(V))
  return

def MagnetOn():
  #Set current level
  AgilentZdrojMagnet.write("OUTP ON")
  return

def MagnetOff():
  #Set current level
  AgilentZdrojMagnet.write("OUTP OFF")
  time.sleep(2) #ceka na zmenu magneticke indukce v magnetu aby se mohla vypnout relatka
  return
  
# konec inicializace komunikace s zdrojem proudu pro magnet Agilent N5769A  
##############################################


##############################################
#inicializace komunikace s digitalni kartou pro relatka Velleman
#import pyk8055  #verbose verze
import pyk8055_nv  #non verbose verze
#Requires Python 2.7, and 32 bit windows
import time
#dev = pyk8055.device()
dev = pyk8055_nv.device()



#konec inicializace komunikace s digitalni kartou pro relatka Velleman
###########################################################

print "KONEC INICIALIZACE KOMUNIKACE S PRISTROJI"
print



#prikazy pro zapnuti pole plus, minus a vypnuti pole. Vypina u toho zdroj proud pro magnet.
BTimeDelay=1  #urcuje casovou mezeru mezi vypinani relatek, kdyz je nula, tak to nefunguje, muze se zrychlit na 0.5s

def BPlusOn():
  dev.digital_on(1) # Turns on digital channel 1
  print "Magneticke pole Plus zapnuto"
  time.sleep(BTimeDelay)
  dev.digital_off(1) # Turns off digital channel 1
  MagnetOn()
  time.sleep(CasovaProdlevaPole)  # cekani na ustabilizovani Pole
  return 


def BOff():
  MagnetOff()
  time.sleep(BTimeDelay)
  dev.digital_on(2) # Turns on digital channel 2
  print "Magneticke pole vypnuto"
  time.sleep(BTimeDelay)
  dev.digital_off(2) # Turns off digital channel 2
  return 


def BMinusOn():
  dev.digital_on(3) # Turns on digital channel 3
  print "Magneticke pole Minus zapnuto"
  time.sleep(BTimeDelay)
  dev.digital_off(3) # Turns off digital channel 3
  MagnetOn()
  time.sleep(CasovaProdlevaPole)  # cekani na ustabilizovani Pole
  return 


TimeCurrentDelay=1  #doba cekani po nastaveni proudu vzorky kvuli stabilizaci, doporucuji nechat na 1s  
# procedura pro nastaveni proudu vzorkem
def NastavProudHall(Proud):
  #print "CURRent "+str(Proud)
  ZdrojProudu("CURRent "+str(Proud)) # nastav proud
  time.sleep(TimeCurrentDelay)  #chvili pocka na ustabilizovani proudu
  return



