//#include <Esplora.h>

#define RELAYPIN1   8   // K1
#define RELAYPIN2   9   // K2
#define RELAYPIN3   10  // K3
#define RELAYPIN4   11  // K4
#define LEDPIN1     2   // LED1 - h
#define LEDPIN2     3   // LED2 - a
#define LEDPIN3     4   // LED3 - b
#define LEDPIN4     5   // LED4 - k
#define LEDPIN5     6   // LED5 - c
#define LEDPIN6     7   // LED6 - d

void setup() {
  // Set all pins as OUTPUT, LOW
  digitalWrite(RELAYPIN1,LOW);
  pinMode(RELAYPIN1,OUTPUT);
  digitalWrite(RELAYPIN2,LOW);
  pinMode(RELAYPIN2,OUTPUT);
  digitalWrite(RELAYPIN3,LOW);
  pinMode(RELAYPIN3,OUTPUT);
  digitalWrite(RELAYPIN4,LOW);
  pinMode(RELAYPIN4,OUTPUT);
  digitalWrite(LEDPIN1,LOW);
  pinMode(LEDPIN1,OUTPUT);
  digitalWrite(LEDPIN2,LOW);
  pinMode(LEDPIN2,OUTPUT);
  digitalWrite(LEDPIN3,LOW);
  pinMode(LEDPIN3,OUTPUT);
  digitalWrite(LEDPIN4,LOW);
  pinMode(LEDPIN4,OUTPUT);
  digitalWrite(LEDPIN5,LOW);
  pinMode(LEDPIN5,OUTPUT);
  digitalWrite(LEDPIN6,LOW);
  pinMode(LEDPIN6,OUTPUT);
  digitalWrite(LEDPIN1,LOW);
  // Start serial communication
  Serial.begin(9600);
}

void loop(){
  getValue();
}

int getValue(){
  Serial.flush();
  byte inByte = '\0';
  char value[5];
  memset(value,'\0',5);
  inByte = Serial.read();

  /*  Table of interconnections
   *  Position  U-  U+  I-  I+
   *  h         D   C   B   A
   *  a         D   B   A   C
   *  b         B   C   D   A
   *  k         A   B   D   C
   *  c         A   C   D   B
   *  d         A   D   C   B
   */
   
  /* Table with output states
   *  Position  Relay1  Relay2  Relay3  Relay4
   *  h         0       0       0       0
   *  a         1       1       0       0
   *  b         0       0       0       1
   *  k         1       1       1       0
   *  c         1       0       1       0
   *  d         0       1       1       1
   */
  // Set all outputs according byte read
  switch (inByte) {
    case 'h':
      digitalWrite(RELAYPIN1, LOW);
      digitalWrite(RELAYPIN2, LOW);
      digitalWrite(RELAYPIN3, LOW);
      digitalWrite(RELAYPIN4, LOW);
      digitalWrite(LEDPIN1, HIGH);
      digitalWrite(LEDPIN2, LOW);
      digitalWrite(LEDPIN3, LOW);
      digitalWrite(LEDPIN4, LOW);
      digitalWrite(LEDPIN5, LOW);
      digitalWrite(LEDPIN6, LOW);
      //Serial.print("hall 1\n");
      break;
    case 'a':
      digitalWrite(RELAYPIN1, HIGH);
      digitalWrite(RELAYPIN2, HIGH);
      digitalWrite(RELAYPIN3, LOW);
      digitalWrite(RELAYPIN4, LOW);
      digitalWrite(LEDPIN1, LOW);
      digitalWrite(LEDPIN2, HIGH);
      digitalWrite(LEDPIN3, LOW);
      digitalWrite(LEDPIN4, LOW);
      digitalWrite(LEDPIN5, LOW);
      digitalWrite(LEDPIN6, LOW);
      //Serial.print("res. 1a\n");
      break;
    case 'b':
      digitalWrite(RELAYPIN1, LOW);
      digitalWrite(RELAYPIN2, LOW);
      digitalWrite(RELAYPIN3, LOW);
      digitalWrite(RELAYPIN4, HIGH);
      digitalWrite(LEDPIN1, LOW);
      digitalWrite(LEDPIN2, LOW);
      digitalWrite(LEDPIN3, HIGH);
      digitalWrite(LEDPIN4, LOW);
      digitalWrite(LEDPIN5, LOW);
      digitalWrite(LEDPIN6, LOW);
      //Serial.print("res. 1b\n");
      break;
    case 'k':
      digitalWrite(RELAYPIN1, HIGH);
      digitalWrite(RELAYPIN2, HIGH);
      digitalWrite(RELAYPIN3, HIGH);
      digitalWrite(RELAYPIN4, LOW);
      digitalWrite(LEDPIN1, LOW);
      digitalWrite(LEDPIN2, LOW);
      digitalWrite(LEDPIN3, LOW);
      digitalWrite(LEDPIN4, HIGH);
      digitalWrite(LEDPIN5, LOW);
      digitalWrite(LEDPIN6, LOW);
      //Serial.print("hall 2\n");
      break;
    case 'c':
      digitalWrite(RELAYPIN1, HIGH);
      digitalWrite(RELAYPIN2, LOW);
      digitalWrite(RELAYPIN3, HIGH);
      digitalWrite(RELAYPIN4, LOW);
      digitalWrite(LEDPIN1, LOW);
      digitalWrite(LEDPIN2, LOW);
      digitalWrite(LEDPIN3, LOW);
      digitalWrite(LEDPIN4, LOW);
      digitalWrite(LEDPIN5, HIGH);
      digitalWrite(LEDPIN6, LOW);
      //Serial.print("res. 2a\n");
      break;
    case 'd':
      digitalWrite(RELAYPIN1, LOW);
      digitalWrite(RELAYPIN2, HIGH);
      digitalWrite(RELAYPIN3, HIGH);
      digitalWrite(RELAYPIN4, HIGH);
      digitalWrite(LEDPIN1, LOW);
      digitalWrite(LEDPIN2, LOW);
      digitalWrite(LEDPIN3, LOW);
      digitalWrite(LEDPIN4, LOW);
      digitalWrite(LEDPIN5, LOW);
      digitalWrite(LEDPIN6, HIGH);
      //Serial.print("res. 2b\n");
      break;
   default:
      break;
    }
    return 0;
  }
